package com.example.nto.controller;


import com.example.nto.entity.Code;
import com.example.nto.entity.Employee;
import com.example.nto.service.impl.EmployeeServiceImpl;
import lombok.RequiredArgsConstructor;
import org.springframework.http.ResponseEntity;
import org.springframework.security.core.Authentication;
import org.springframework.web.bind.annotation.*;

@RestController
@RequiredArgsConstructor
@RequestMapping("/api")
public class EmployeeController {

    private final EmployeeServiceImpl employeeService;

    @GetMapping("/login")
    public ResponseEntity<Employee> login(Authentication authentication){
        return ResponseEntity.ok(employeeService.getEmployeeByUsername(authentication.getName()));
    }

    @GetMapping("/info/{login}")
    public Employee info(@PathVariable("login") String username){
        return employeeService.getInfo(username);
    }

    @PatchMapping("/open/{login}")
    public String open(@PathVariable("login") String login, @RequestBody Code value){
        return employeeService.patchOpen(login, value.getValue());
    }
}
