package com.example.nto.service.impl;

import com.example.nto.entity.Code;
import com.example.nto.entity.Employee;
import com.example.nto.exception.EmployeeNotFoundException;
import com.example.nto.repository.CodeRepository;
import com.example.nto.repository.EmployeeRepository;
import com.example.nto.service.EmployeeService;
import lombok.RequiredArgsConstructor;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Service;
import org.springframework.web.server.ResponseStatusException;

import java.util.Optional;

import static org.springframework.util.Assert.hasText;

@Service
@RequiredArgsConstructor
public class EmployeeServiceImpl implements EmployeeService {

    private final EmployeeRepository employeeRepository;
    private final CodeRepository codeRepository;

    @Override
    public Employee getEmployeeByUsername(String username) {
        Optional<Employee> optionalEmployee = employeeRepository.findByUsername(username);

        if(optionalEmployee.isEmpty())
            throw new EmployeeNotFoundException("Employee with username: " + username + " not found");

        return optionalEmployee.get();
    }

    @Override
    public Employee getInfo(String username) {
        Optional<Employee> optionalEmployee = employeeRepository.findByUsername(username);
        if(optionalEmployee.isEmpty()) {
            throw new EmployeeNotFoundException("Employee with username: " + username + " not found");
        }

        return optionalEmployee.get();
    }

    @Override
    public String patchOpen(String username, long value) {

        return ("Дверь открыта");
    }
}
